/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import block.Block;
import game.Game;
import game.Ghost;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import java.awt.GraphicsEnvironment;
import java.awt.Label;
import java.awt.Toolkit;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.geom.AffineTransform;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import main.SoundEffects;
import score.Score;



/**
 *
 * @author s070280
 */
public class GUIGame extends JPanel {

    
    public GUIGame(GUIFrame f, GUIMainMenu mainMenu, String name, String difficulti){
        titleFont = new Font("Arial Black", Font.BOLD, 26); 
        setVisible(true);
        setLayout(null);
        setFocusable(true);
        addKeyListener(new TAdapter());
        frame = f;        
        frame.getContentPane().setPreferredSize(new Dimension(1280,800));
        frame.setLocation(GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().x-640, GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().y-400);        
        
        difficulty = difficulti;
        
        levelName = name;
        
        titleLabel = new Label(levelName.toUpperCase());
        titleLabel.setSize(220,30);
        titleLabel.setLocation(30,165);
        titleLabel.setBackground(Color.black);
        titleLabel.setForeground(Color.yellow);
        titleLabel.setAlignment(Label.CENTER);
        titleLabel.setFont(titleFont);
        this.add(titleLabel);
        
        scoreLabel = new Label("0");
        scoreLabel.setSize(200,30);
        scoreLabel.setLocation(40,260);
        scoreLabel.setBackground(Color.black);
        scoreLabel.setForeground(Color.yellow);
        scoreLabel.setAlignment(Label.CENTER);
        scoreLabel.setFont(titleFont);
        this.add(scoreLabel);
        
        Score top = new Score();
        int[] s = top.getTopScores(levelName);
        if(levelName.equals("level1")) {
            s = top.getTopScores("level5");
        }
        topscoreLabel = new Label(Integer.toString(s[0]));
        topscoreLabel.setSize(200,30);
        topscoreLabel.setLocation(40,380);
        topscoreLabel.setBackground(Color.black);
        topscoreLabel.setForeground(Color.yellow);        
        topscoreLabel.setAlignment(Label.CENTER);
        topscoreLabel.setFont(titleFont);
        this.add(topscoreLabel);
        
        timeLabel = new Label("0");
        timeLabel.setSize(200,30);
        timeLabel.setLocation(40,720);
        timeLabel.setBackground(Color.black);
        timeLabel.setForeground(Color.yellow);        
        timeLabel.setAlignment(Label.CENTER);
        timeLabel.setFont(titleFont);
        this.add(timeLabel);
        
        frame.pack();
        menu=mainMenu;
        
        currentGame = new Game(levelName, this, difficulty);
        currentGame.startGame();
        currentLevelArray = currentGame.currentLevel.levelArray;
        
        
    } 
    
        
    public void endGameHandler(Boolean packdotsEaten) {
        currentGame.score.setScore(5000*currentGame.currentLevel.lives,currentGame.currentTime/6000); 
        if (packdotsEaten && currentGame.currentLevel.lives > 0) {
            if (levelName.startsWith("level") && Integer.parseInt(levelName.substring(5)) < 5 ) {
                currentGame.goToNextLevel("level" + Integer.toString(Integer.parseInt(levelName.substring(5))+1));
                currentLevelArray = currentGame.currentLevel.levelArray;
                levelName = "level" + Integer.toString(Integer.parseInt(levelName.substring(5))+1);
                titleLabel.setText(levelName.toUpperCase());
            } else {
                currentGame.endGame();               
                if (levelName.equals("level5")){
                    Thread tsound = new Thread(new SoundEffects("win"));
                    tsound.start();
                    
                    JOptionPane.showMessageDialog(frame,
                    "You've succesfully completed the standard levels!",
                    "The End.",
                    JOptionPane.PLAIN_MESSAGE);
                }
                else {
                    Thread tsound = new Thread(new SoundEffects("win"));
                    tsound.start();
                    
                    JOptionPane.showMessageDialog(frame,
                    "You've succesfully completed the level!",
                    "Level completed.",
                    JOptionPane.PLAIN_MESSAGE);
                }
                
                if(levelName.startsWith("level")) { levelName = "level5"; }
                
                if(currentGame.score.checkTopscore(levelName)!=-1) {
                    String playerName = askForTopScoreName(); // Ask for name
                    currentGame.score.saveTopscore(levelName, playerName);
                }
                else {
                    JOptionPane.showMessageDialog(frame,
                    "No new highscore! You got "
                            + Integer.toString(currentGame.score.currentScore) +
                            " points.",
                    "Too bad!",
                    JOptionPane.PLAIN_MESSAGE);
                }
                frame.add(new GUITopscores(frame, menu, levelName));
                setVisible(false);
                frame.getContentPane().setPreferredSize(new Dimension(640,480));
                frame.setLocation(GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().x-300, GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().y-200);        
                frame.pack();                 
            }    
            
        } else {
            currentGame.endGame();
            JOptionPane.showMessageDialog(frame,
            "Too bad! You had "
                    + Integer.toString(currentGame.score.currentScore) +
                    " points when you died.",
            "You died!",
            JOptionPane.PLAIN_MESSAGE);
            
            if(levelName.startsWith("level")) { levelName = "level5"; }
            
            if(currentGame.score.checkTopscore(levelName)!=-1) {
                    String playerName = askForTopScoreName(); // Ask for name
                    currentGame.score.saveTopscore(levelName, playerName);
                }
            
            frame.add(new GUITopscores(frame, menu, levelName));
            setVisible(false);
            frame.getContentPane().setPreferredSize(new Dimension(640,480));
            frame.setLocation(GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().x-300, GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().y-200);        
            frame.pack(); 
        }

    }
    
    
    private String askForTopScoreName() {
        
        JTextField nameField = new JTextField();

        Object[] message = new Object[] { "Please enter your name: ", nameField};
        String name = "Player";
        int r = JOptionPane.showConfirmDialog(this, message, "New Highscore!", JOptionPane.PLAIN_MESSAGE);
        if (r == JOptionPane.OK_OPTION) {
            name = nameField.getText();
        }
        return name;
    }
    
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2d = (Graphics2D) g;
        g.drawImage(new ImageIcon(this.getClass().getResource("/img/gamescreen.png")).getImage(), 0, 0, null);  
        
        scoreLabel.setText(Integer.toString(currentGame.score.currentScore+currentGame.score.getPoints()));
        
        currentSeconds = (int)((currentGame.currentTime)/1000)%60;
        currentMinutes = (int)((currentGame.currentTime)/60000);
        
        if (currentSeconds <= 9) {
            timeLabel.setText(Integer.toString(currentMinutes)+":0"+Integer.toString(currentSeconds));
        }
        else timeLabel.setText(Integer.toString(currentMinutes)+":"+Integer.toString(currentSeconds));
        
        for (int l=0; l<= currentGame.currentLevel.lives -1 ; l++) {
            g.drawImage(new ImageIcon(this.getClass().getResource("/img/pacman4.gif")).getImage(), 87+l*40, 485, null);
        }
        
        for(int i=0;i<currentLevelArray.length;i++){
            for(int j=0;j<currentLevelArray[0].length;j++){
                g2d.drawImage(currentLevelArray[i][j].getImage(), 270 + j*30, 150 + i*30, this);
            }
        }
        
        AffineTransform transform = new AffineTransform();
        transform.translate(currentGame.currentLevel.pacman.getCoordinateX() + 270, currentGame.currentLevel.pacman.getCoordinateY() + 150);
        transform.rotate(Math.toRadians(currentGame.currentLevel.pacman.getSpriteRotation()), 15, 15);
        g2d.drawImage(currentGame.currentLevel.pacman.getImage(), transform, this);        
        
        for(Ghost ghost : currentGame.currentLevel.ghosts){
            g2d.drawImage(ghost.getImage(), ghost.getCoordinateX() + 270, ghost.getCoordinateY() + 150, this);
        } 
        
        Toolkit.getDefaultToolkit().sync();
        g.dispose();
    }  
    
    @Override
    public void addNotify() {
        super.addNotify();
        animator = new Thread(currentGame);
        animator.start();       
    }  
       
    private class TAdapter extends KeyAdapter {     
        
        @Override
        public void keyPressed(KeyEvent e) {
            if(e.getKeyCode()==KeyEvent.VK_ESCAPE){
                currentGame.endGame();
                setVisible(false);
                menu.setVisible(true);
                frame.getContentPane().setPreferredSize(new Dimension(640,480));
                frame.setLocation(GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().x-300, GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint().y-200);        
                frame.pack();                 
            }
            
            if(e.getKeyCode()==KeyEvent.VK_P){
                currentGame.pauseGame();
            }
            
            
            currentGame.currentLevel.pacman.keyPressed(e);
        }
    }
    
    private GUIMainMenu menu;
    public GUIFrame frame;
    private Game currentGame;
    private String levelName;
    private Block[][] currentLevelArray;
    private Thread animator;
    public String difficulty;
    
    public int currentSeconds;
    public int currentMinutes;
    
    private Label titleLabel;
    private Label scoreLabel;
    private Label topscoreLabel;
    private Label timeLabel;
    Font titleFont;
}
