/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;

/**
 *
 * @author s070280
 */
public class GUIMainMenu extends JPanel {

    public GUIMainMenu(GUIFrame f) {
        frame = f;
        setLayout(null);   
        String[] menuList = new String[]{"play", "leveleditor","topscores","howtoplay","controls","credits","exit"};
        menuButtons = Arrays.asList(menuList);        
        createButtons();      
    }
    
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(new ImageIcon(this.getClass().getResource("/img/main.png")).getImage(), 0, 0, null);

    }

    private void createButtons() {
        for(int i=0;i<menuButtons.size();i++){
            String btnName = "/img/menu_" + menuButtons.get(i).toString() + ".png";
            JButton btn = new JButton(new ImageIcon(this.getClass().getResource(btnName)));
            btn.setBounds(196, 110 + i*50, 248, 47);
            btn.addActionListener(new ButtonListener());
            btn.setName(menuButtons.get(i).toString());
            this.add(btn);
        }
        
    }

    class ButtonListener implements ActionListener {
        
        @Override
        public void actionPerformed(ActionEvent e) {
            JButton o = (JButton) e.getSource();
            String name = o.getName();

            if ("play".equals(name)) {
                frame.add(new GUISelectLevel(frame,menu));
                setVisible(false);
            } else if ("leveleditor".equals(name)) {
                frame.add(new GUILevelEditorSelect(frame,menu));
                setVisible(false);                
            } else if ("topscores".equals(name)) {
                frame.add(new GUITopscoresSelect(frame,menu));
                setVisible(false);                
            } else if ("howtoplay".equals(name)) {
                frame.add(new GUIHowtoplay(frame,menu));
                setVisible(false);
            } else if ("controls".equals(name)) {
                frame.add(new GUIControls(frame,menu));
                setVisible(false);
            } else if ("credits".equals(name)){
                frame.add(new GUICredits(frame,menu));
                setVisible(false);
            } else if ("exit".equals(name)) {
                frame.dispose();
                frame.removeAll();
                System.exit(0);
            } 
            
        }
    }
    
    private GUIMainMenu menu = this;
    private GUIFrame frame;
    private List<String> menuButtons = new ArrayList<String>();
}
