/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FilenameFilter;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author s070280
 */
public class GUISelectLevel extends JPanel{

    
    public GUISelectLevel(GUIFrame f, GUIMainMenu mainMenu){
        setVisible(true);
        setLayout(null);
        frame = f;
        menu = mainMenu;
        difficulty = "normal";
        diff = 0;
       
        
        back = new JButton(new ImageIcon(this.getClass().getResource("/img/return.png")));
        back.setBounds(20, 410, 290, 62); 
        back.addActionListener(new ActionListener(){
            @Override
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
                menu.setVisible(true);
            }
        });
        add(back);
        
        playcus = new JButton(new ImageIcon(this.getClass().getResource("/img/selectlevel_playcustomlevel.png")));
        playcus.setBounds(330, 410, 290, 62); 
        playcus.addActionListener(new ActionListener(){
            @Override
            public void actionPerformed(ActionEvent e) {
                frame.add(new GUIGame(frame, menu, selectedLevel,difficulty));
                setVisible(false);
            }
        });
        add(playcus);
        
        playstd = new JButton(new ImageIcon(this.getClass().getResource("/img/selectlevel_playstandardlevels.png")));
        playstd.setBounds(265, 32, 300, 110); 
        playstd.addActionListener(new ActionListener(){
            @Override            
            public void actionPerformed(ActionEvent e) {
                frame.add(new GUIGame(frame,menu,"level1",difficulty));
                setVisible(false); 
            }
        });
        add(playstd); 
  
        normal = new JButton(new ImageIcon(this.getClass().getResource("/img/selectlevel_normal.png")));
        normal.setBounds(120, 82, 90, 25);
        normal.addActionListener(new ActionListener(){
            @Override
            public void actionPerformed(ActionEvent e) {
                difficulty = "normal";
                diff = 0;
                repaint();
            }
        });
        add(normal);
        
        hard = new JButton(new ImageIcon(this.getClass().getResource("/img/selectlevel_hard.png")));
        hard.setBounds(120, 112, 60, 25);
        hard.addActionListener(new ActionListener(){
            @Override
            public void actionPerformed(ActionEvent e) {
                difficulty = "hard";
                diff = 30;
                repaint();
            }
        });
        add(hard);
        
        String[] fileList = getLevelfiles();
        selectedLevel = fileList[0];
        
        list = new JList(fileList);
        list.setBackground(Color.black);
        list.setForeground(Color.yellow);
        Font displayFont = new Font("Arial Black", Font.BOLD, 22);
        list.setFont(displayFont);
        list.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
               String levelName = (String) list.getSelectedValue();
               selectedLevel = levelName.toLowerCase();
            }
        });

        pane = new JScrollPane(list);
        pane.setPreferredSize(new Dimension(290, 170));
        pane.setBounds(180, 195, 290, 170);
        pane.getViewport().setBackground(Color.BLACK);
        pane.setVisible(true);
        add(pane);   
    
    }
    
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(new ImageIcon(this.getClass().getResource("/img/selectlevel_background.png")).getImage(), 0, 0, null);
        g.drawImage(new ImageIcon(this.getClass().getResource("/img/selectlevel_diamond.png")).getImage(), 100, 87+diff, null);
    }  
    
    private String[] getLevelfiles() {
        File f = new File("");        
        String dir = f.getAbsolutePath() + "/levels";
        f = new File(dir);
        FilenameFilter filter = new ExtenstionFilter("level");
        File[] files = f.listFiles(filter);

        ArrayList<String> filenames = new ArrayList(); 
        String temp = null;
        for (int i =0; i < files.length; i++) {
            temp = files[i].getName().toUpperCase();
            if (!temp.startsWith("LEVEL")) {
                filenames.add(temp.substring(0, temp.indexOf(".")));
            }            
        }
        String []strArray = new String[filenames.size()];
        filenames.toArray(strArray);
        return strArray;
    }

    private class ExtenstionFilter implements FilenameFilter {
        String ext;
        public ExtenstionFilter(String ext) {
            this.ext = "." + ext;
        }        

        public boolean accept(File dir, String name) {
            return name.endsWith(ext);
        }
    }

    
    
    private GUIMainMenu menu;
    private JButton back;
    private JButton playcus;
    private JButton playstd;
    private JButton normal;
    private JButton hard;
    public GUIFrame frame;
    private JList list;
    private JScrollPane pane;
    private String selectedLevel;
    private String difficulty;
    private Image diffIm;
    private int diff;
    
}
