package gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
import score.Score;



public class GUITopscores extends JPanel{

    
    public GUITopscores(GUIFrame f, GUIMainMenu mainMenu, String levelName){
        score = new Score();
        
        displayFont = new Font("Arial Black", Font.BOLD, 22);
        titleFont = new Font("Arial Black", Font.BOLD, 38); 
        scoreFont = new Font("Arial Black", Font.BOLD, 30);
        
        if(levelName.startsWith("level")) {
            levelName = "level5";
        }
        
        topScores = score.getTopScores(levelName);
        topNames = score.getTopNames(levelName);
        
        setVisible(true);
        setLayout(null);
        frame = f;
        menu = mainMenu;
        
        displayScores();
        displayNames();
        
        if(levelName.startsWith("level")) {
            levelName = "Standard Levels";
        }
        // Create title
        label = new Label(levelName.toUpperCase());
        label.setSize(480,30);
        label.setLocation(80,110);
        label.setBackground(Color.black);
        label.setForeground(Color.yellow);
        label.setFont(titleFont);
        this.add(label);
        
        back = new JButton(new ImageIcon(this.getClass().getResource("/img/return.png")));
        back.setBounds(20, 410, 290, 62); 
        back.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                setVisible(false);
                menu.setVisible(true);
            }
        });
        add(back);
    }
    
    private void displayScores() {
        String temp;
        for(int i=0 ; i<5 ; i++) {
            temp = Integer.toString(topScores[i]);
            label = new Label(temp);
            label.setSize(130,40);
            label.setLocation(77,160+40*i);
            label.setBackground(Color.black);
            label.setForeground(Color.yellow);
            label.setFont(scoreFont);
            this.add(label);           
        }

    }
    
    private void displayNames() {
        String temp;
        for(int i=0 ; i<5 ; i++) {
            temp = topNames[i];
            label = new Label(temp);
            label.setSize(350,40);
            label.setLocation(210,160+40*i);
            label.setBackground(Color.black);
            label.setForeground(Color.yellow);
            label.setFont(scoreFont);
            this.add(label);           
        }

    }    
    
    public void paintComponent(Graphics g) {
        g.drawImage(new ImageIcon(this.getClass().getResource("/img/topscores_main.png")).getImage(), 0, 0, null);  
    }  
    
    private GUIMainMenu menu;
    private JButton back;
    public GUIFrame frame;
    private Label label;
    
    Font displayFont;
    Font titleFont;
    Font scoreFont;
    
    private Score score;
    private int[] topScores;
    private String[] topNames;
}