/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package leveleditor;
//import GEM.*;
import java.io.File;
import java.util.*;

import block.*;
import java.io.FilenameFilter;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Blockbuilder gets all available classes that extend Block from
 * @author s070280
 */
public class BlockBuilder {

    public BlockBuilder() {
        //blocks = getClassesFromJar();
        blocks = getClasses();
    }

    public Block getBlockfromString(String blockString) {
        String pathType, parameter; //to store the pathtype and parameter
        int underscore; //place of the underscore in a parameter
        Block newBlock = null; //return the desired block
        try {
            underscore = blockString.indexOf("_");
            if (underscore == -1) { //if no underscore detected                
                newBlock = (Block) blocks.get(blockString).getConstructor().newInstance();
            } else {
                pathType = blockString.substring(0, underscore);
                parameter = blockString.substring(underscore + 1);
                newBlock = (Block) blocks.get(pathType).getConstructor(String.class).newInstance(parameter);
            }
        } catch (Exception ex) {
            // Do nothing
        }
        return newBlock;
    }

    /**
     * This function gets the class objects from the file structure inside the block section.
     * @return HashMap<String, Class>
     */
    private HashMap<String, Class> getClasses() {
        HashMap<String, Class> blockMap = new HashMap<String, Class>();
        File f = new File("");
        String dir = "build/classes/block";
        f = new File(dir);
        FilenameFilter filter = new ExtenstionFilter("class");
        try {
            for (File file : f.listFiles(filter)) {
                String className = file.getName();
                int sc = className.indexOf(".");
                if ((sc != -1) && className.indexOf("$") == -1) {
                    className = "block." + className.substring(0, sc);
                    Class c = Class.forName(className);
                    if (c.getSuperclass().getSimpleName().equals("Block")) {
                        blockMap.put(c.getSimpleName().toLowerCase(), c);
                    }
                }
            }
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(BlockBuilder.class.getName()).log(Level.SEVERE, null, ex);
        } catch (Exception ex) {
            Logger.getLogger(BlockBuilder.class.getName()).log(Level.SEVERE, null, ex);
        }
        return blockMap;
    }

    /*
     * This function is used for filtering only the files with right extension.
     */
    private class ExtenstionFilter implements FilenameFilter {

        String ext;

        public ExtenstionFilter(String ext) {
            this.ext = "." + ext;
        }

        @Override
        public boolean accept(File dir, String name) {
            return name.endsWith(ext);
        }
    }

    private HashMap<String, Class> getClassesFromJar() {
        HashMap<String, Class> blockMap = new HashMap<String, Class>();
        String pathSep = System.getProperty("file.separator");
        File dir = new File("");
        String test = dir.getAbsolutePath();
        String jarPath = "Pac-Man.jar";//test + pathSep + "dist" + pathSep + "Pac-Man.jar";
        try {
            JarFile jf = new JarFile(jarPath);
            for (Enumeration<JarEntry> jes = jf.entries(); jes.hasMoreElements();) {
                String className = jes.nextElement().getName();                    
                int sc = className.indexOf(".");
                int sl = className.indexOf("/");
                if ((sc != -1) && className.indexOf("$") == -1 && className.startsWith("block/") && className.endsWith(".class")) {
                    className = "block." + className.substring(sl+1, sc);
                    Class c = Class.forName(className);
                    if (c.getSuperclass().getSimpleName().equals("Block")) {
                        blockMap.put(c.getSimpleName().toLowerCase(), c);
                    }
                }
                
            }
        } catch (Exception e) {
            // ignore exceptions - these are supposed to happen
            //System.out.println(e.toString());
        }
        return blockMap;
    }

    public HashMap<String, Class> blocks;
}
